/*
 * This file was generated automatically by ExtUtils::ParseXS version 3.43 from the
 * contents of Mixer.xs. Do not edit this file, edit Mixer.xs instead.
 *
 *    ANY CHANGES MADE HERE WILL BE LOST!
 *
 */

#line 1 "Mixer.xs"
#include "EXTERN.h"
#include "perl.h"
#include "XSUB.h"

#include "ppport.h"

#define MAX_AMPL 	32767
#define PCM_RATE	176400

struct crossfade_channels_s {
	short left;
	short right;
};

struct crossfade_s {
	int len;
	short *spline_out;
	short *spline_in;
};

int crossfade_ease_in_out_quad_func (float t, float b, float c, float d) {
	return -c *(t/=d)*(t-2) + b;
}

char *crossfade_build_easeout_quad_spline (int d) {
	unsigned int t = 0, v;
	short *spline, *s;
	
	d *= 44100;
	if ((spline = (short *) malloc(sizeof(short) * d)) == NULL)
		return NULL;
	
	s = spline;
	while (t != d) {
		v = crossfade_ease_in_out_quad_func(t++, 0, MAX_AMPL, d);	

		*s++ = MAX_AMPL - v;
	}
	
	return spline;
}

char *crossfade_build_easein_quad_spline (int d) {
	int t = 0, v;
	short *spline, *s;
	
	d *= 44100;
	if ((spline = (short *) malloc(sizeof(short) * d)) == NULL)
		return NULL;
	
	s = spline;
	while (t != d) {
		v = crossfade_ease_in_out_quad_func(t++, 0, MAX_AMPL, d);

		*s++ = v;
	}
	
	return spline;
}

struct crossfade_s *crossfade_init (int duration) {
	struct crossfade_s *crossfade = NULL;
	
	if ((crossfade = (struct crossfade_s *) malloc(sizeof (struct crossfade_s))) == NULL)
		return NULL;
	memset (crossfade, 0, sizeof (struct crossfade_s));
	
	if ((crossfade->spline_out = (short *) crossfade_build_easeout_quad_spline(duration)) == NULL)
		goto clean;
	
	if ((crossfade->spline_in = (short *) crossfade_build_easein_quad_spline(duration)) == NULL)
		goto clean;	
		
	crossfade->len  = duration * PCM_RATE;
	
	return crossfade;
	
clean:
	if (crossfade->spline_out)
		free (crossfade->spline_out);
	if (crossfade->spline_in)
		free (crossfade->spline_in);
	
	return NULL;
}

unsigned int CROSSFADE_init (int duration) {
	return (unsigned int) crossfade_init(duration);
}

void crossfade_ease_in_out_quad (struct crossfade_s *crossfade, char *out, char *in, char *result) {
	struct crossfade_channels_s *chout, *chin, *chresult;
	short *spout, *spin;
	double dout, din;
	int r = 0;
	
	chout = (struct crossfade_channels_s *) out;
	chin = (struct crossfade_channels_s *) in;
	chresult = (struct crossfade_channels_s *) result;
	
	spout = crossfade->spline_out;
	spin = crossfade->spline_in;
	
	while (r < crossfade->len) {
		dout = ((double) *spout) / MAX_AMPL;
		din = ((double) *spin) / MAX_AMPL;
		
		chresult->left = (double) chout->left * dout + (double) chin->left * din;
		chresult->right = (double) chout->right * dout + (double) chin->right * din;
		
		chout++;
		chin++;
		chresult++;
		spout++;
		spin++;
		
		r += sizeof (struct crossfade_channels_s);
	}
}

void CROSSFADE_ease_in_out_quad (int crossfade, SV *out, SV *in, SV *result) {
	crossfade_ease_in_out_quad ((struct crossfade_s *) crossfade, SvPVX(out), SvPVX(in), SvPVX(result));
}


#line 136 "Mixer.c"
#ifndef PERL_UNUSED_VAR
#  define PERL_UNUSED_VAR(var) if (0) var = var
#endif

#ifndef dVAR
#  define dVAR		dNOOP
#endif


/* This stuff is not part of the API! You have been warned. */
#ifndef PERL_VERSION_DECIMAL
#  define PERL_VERSION_DECIMAL(r,v,s) (r*1000000 + v*1000 + s)
#endif
#ifndef PERL_DECIMAL_VERSION
#  define PERL_DECIMAL_VERSION \
	  PERL_VERSION_DECIMAL(PERL_REVISION,PERL_VERSION,PERL_SUBVERSION)
#endif
#ifndef PERL_VERSION_GE
#  define PERL_VERSION_GE(r,v,s) \
	  (PERL_DECIMAL_VERSION >= PERL_VERSION_DECIMAL(r,v,s))
#endif
#ifndef PERL_VERSION_LE
#  define PERL_VERSION_LE(r,v,s) \
	  (PERL_DECIMAL_VERSION <= PERL_VERSION_DECIMAL(r,v,s))
#endif

/* XS_INTERNAL is the explicit static-linkage variant of the default
 * XS macro.
 *
 * XS_EXTERNAL is the same as XS_INTERNAL except it does not include
 * "STATIC", ie. it exports XSUB symbols. You probably don't want that
 * for anything but the BOOT XSUB.
 *
 * See XSUB.h in core!
 */


/* TODO: This might be compatible further back than 5.10.0. */
#if PERL_VERSION_GE(5, 10, 0) && PERL_VERSION_LE(5, 15, 1)
#  undef XS_EXTERNAL
#  undef XS_INTERNAL
#  if defined(__CYGWIN__) && defined(USE_DYNAMIC_LOADING)
#    define XS_EXTERNAL(name) __declspec(dllexport) XSPROTO(name)
#    define XS_INTERNAL(name) STATIC XSPROTO(name)
#  endif
#  if defined(__SYMBIAN32__)
#    define XS_EXTERNAL(name) EXPORT_C XSPROTO(name)
#    define XS_INTERNAL(name) EXPORT_C STATIC XSPROTO(name)
#  endif
#  ifndef XS_EXTERNAL
#    if defined(HASATTRIBUTE_UNUSED) && !defined(__cplusplus)
#      define XS_EXTERNAL(name) void name(pTHX_ CV* cv __attribute__unused__)
#      define XS_INTERNAL(name) STATIC void name(pTHX_ CV* cv __attribute__unused__)
#    else
#      ifdef __cplusplus
#        define XS_EXTERNAL(name) extern "C" XSPROTO(name)
#        define XS_INTERNAL(name) static XSPROTO(name)
#      else
#        define XS_EXTERNAL(name) XSPROTO(name)
#        define XS_INTERNAL(name) STATIC XSPROTO(name)
#      endif
#    endif
#  endif
#endif

/* perl >= 5.10.0 && perl <= 5.15.1 */


/* The XS_EXTERNAL macro is used for functions that must not be static
 * like the boot XSUB of a module. If perl didn't have an XS_EXTERNAL
 * macro defined, the best we can do is assume XS is the same.
 * Dito for XS_INTERNAL.
 */
#ifndef XS_EXTERNAL
#  define XS_EXTERNAL(name) XS(name)
#endif
#ifndef XS_INTERNAL
#  define XS_INTERNAL(name) XS(name)
#endif

/* Now, finally, after all this mess, we want an ExtUtils::ParseXS
 * internal macro that we're free to redefine for varying linkage due
 * to the EXPORT_XSUB_SYMBOLS XS keyword. This is internal, use
 * XS_EXTERNAL(name) or XS_INTERNAL(name) in your code if you need to!
 */

#undef XS_EUPXS
#if defined(PERL_EUPXS_ALWAYS_EXPORT)
#  define XS_EUPXS(name) XS_EXTERNAL(name)
#else
   /* default to internal */
#  define XS_EUPXS(name) XS_INTERNAL(name)
#endif

#ifndef PERL_ARGS_ASSERT_CROAK_XS_USAGE
#define PERL_ARGS_ASSERT_CROAK_XS_USAGE assert(cv); assert(params)

/* prototype to pass -Wmissing-prototypes */
STATIC void
S_croak_xs_usage(const CV *const cv, const char *const params);

STATIC void
S_croak_xs_usage(const CV *const cv, const char *const params)
{
    const GV *const gv = CvGV(cv);

    PERL_ARGS_ASSERT_CROAK_XS_USAGE;

    if (gv) {
        const char *const gvname = GvNAME(gv);
        const HV *const stash = GvSTASH(gv);
        const char *const hvname = stash ? HvNAME(stash) : NULL;

        if (hvname)
	    Perl_croak_nocontext("Usage: %s::%s(%s)", hvname, gvname, params);
        else
	    Perl_croak_nocontext("Usage: %s(%s)", gvname, params);
    } else {
        /* Pants. I don't think that it should be possible to get here. */
	Perl_croak_nocontext("Usage: CODE(0x%" UVxf ")(%s)", PTR2UV(cv), params);
    }
}
#undef  PERL_ARGS_ASSERT_CROAK_XS_USAGE

#define croak_xs_usage        S_croak_xs_usage

#endif

/* NOTE: the prototype of newXSproto() is different in versions of perls,
 * so we define a portable version of newXSproto()
 */
#ifdef newXS_flags
#define newXSproto_portable(name, c_impl, file, proto) newXS_flags(name, c_impl, file, proto, 0)
#else
#define newXSproto_portable(name, c_impl, file, proto) (PL_Sv=(SV*)newXS(name, c_impl, file), sv_setpv(PL_Sv, proto), (CV*)PL_Sv)
#endif /* !defined(newXS_flags) */

#if PERL_VERSION_LE(5, 21, 5)
#  define newXS_deffile(a,b) Perl_newXS(aTHX_ a,b,file)
#else
#  define newXS_deffile(a,b) Perl_newXS_deffile(aTHX_ a,b)
#endif

#line 280 "Mixer.c"

XS_EUPXS(XS_Audio__C4Stream__Mixer_crossfade_ease_in_out_quad_func); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Audio__C4Stream__Mixer_crossfade_ease_in_out_quad_func)
{
    dVAR; dXSARGS;
    if (items != 4)
       croak_xs_usage(cv,  "t, b, c, d");
    {
	float	t = (float)SvNV(ST(0))
;
	float	b = (float)SvNV(ST(1))
;
	float	c = (float)SvNV(ST(2))
;
	float	d = (float)SvNV(ST(3))
;
	int	RETVAL;
	dXSTARG;

	RETVAL = crossfade_ease_in_out_quad_func(t, b, c, d);
	XSprePUSH; PUSHi((IV)RETVAL);
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Audio__C4Stream__Mixer_crossfade_build_easeout_quad_spline); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Audio__C4Stream__Mixer_crossfade_build_easeout_quad_spline)
{
    dVAR; dXSARGS;
    if (items != 1)
       croak_xs_usage(cv,  "d");
    {
	int	d = (int)SvIV(ST(0))
;
	char *	RETVAL;
	dXSTARG;

	RETVAL = crossfade_build_easeout_quad_spline(d);
	sv_setpv(TARG, RETVAL); XSprePUSH; PUSHTARG;
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Audio__C4Stream__Mixer_crossfade_build_easein_quad_spline); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Audio__C4Stream__Mixer_crossfade_build_easein_quad_spline)
{
    dVAR; dXSARGS;
    if (items != 1)
       croak_xs_usage(cv,  "d");
    {
	int	d = (int)SvIV(ST(0))
;
	char *	RETVAL;
	dXSTARG;

	RETVAL = crossfade_build_easein_quad_spline(d);
	sv_setpv(TARG, RETVAL); XSprePUSH; PUSHTARG;
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Audio__C4Stream__Mixer_CROSSFADE_init); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Audio__C4Stream__Mixer_CROSSFADE_init)
{
    dVAR; dXSARGS;
    if (items != 1)
       croak_xs_usage(cv,  "duration");
    {
	int	duration = (int)SvIV(ST(0))
;
	unsigned int	RETVAL;
	dXSTARG;

	RETVAL = CROSSFADE_init(duration);
	XSprePUSH; PUSHu((UV)RETVAL);
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Audio__C4Stream__Mixer_CROSSFADE_ease_in_out_quad); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Audio__C4Stream__Mixer_CROSSFADE_ease_in_out_quad)
{
    dVAR; dXSARGS;
    if (items != 4)
       croak_xs_usage(cv,  "crossfade, out, in, result");
    PERL_UNUSED_VAR(ax); /* -Wall */
    SP -= items;
    {
	int	crossfade = (int)SvIV(ST(0))
;
	SV *	out = ST(1)
;
	SV *	in = ST(2)
;
	SV *	result = ST(3)
;
#line 157 "Mixer.xs"
	I32* temp;
#line 383 "Mixer.c"
#line 159 "Mixer.xs"
	temp = PL_markstack_ptr++;
	CROSSFADE_ease_in_out_quad(crossfade, out, in, result);
	if (PL_markstack_ptr != temp) {
          /* truly void, because dXSARGS not invoked */
	  PL_markstack_ptr = temp;
	  XSRETURN_EMPTY; /* return empty stack */
        }
        /* must have used dXSARGS; list context implied */
	return; /* assume stack size is correct */
#line 394 "Mixer.c"
	PUTBACK;
	return;
    }
}

#ifdef __cplusplus
extern "C"
#endif
XS_EXTERNAL(boot_Audio__C4Stream__Mixer); /* prototype to pass -Wmissing-prototypes */
XS_EXTERNAL(boot_Audio__C4Stream__Mixer)
{
#if PERL_VERSION_LE(5, 21, 5)
    dVAR; dXSARGS;
#else
    dVAR; dXSBOOTARGSXSAPIVERCHK;
#endif
#if PERL_VERSION_LE(5, 8, 999) /* PERL_VERSION_LT is 5.33+ */
    char* file = __FILE__;
#else
    const char* file = __FILE__;
#endif

    PERL_UNUSED_VAR(file);

    PERL_UNUSED_VAR(cv); /* -W */
    PERL_UNUSED_VAR(items); /* -W */
#if PERL_VERSION_LE(5, 21, 5)
    XS_VERSION_BOOTCHECK;
#  ifdef XS_APIVERSION_BOOTCHECK
    XS_APIVERSION_BOOTCHECK;
#  endif
#endif

        newXS_deffile("Audio::C4Stream::Mixer::crossfade_ease_in_out_quad_func", XS_Audio__C4Stream__Mixer_crossfade_ease_in_out_quad_func);
        newXS_deffile("Audio::C4Stream::Mixer::crossfade_build_easeout_quad_spline", XS_Audio__C4Stream__Mixer_crossfade_build_easeout_quad_spline);
        newXS_deffile("Audio::C4Stream::Mixer::crossfade_build_easein_quad_spline", XS_Audio__C4Stream__Mixer_crossfade_build_easein_quad_spline);
        newXS_deffile("Audio::C4Stream::Mixer::CROSSFADE_init", XS_Audio__C4Stream__Mixer_CROSSFADE_init);
        newXS_deffile("Audio::C4Stream::Mixer::CROSSFADE_ease_in_out_quad", XS_Audio__C4Stream__Mixer_CROSSFADE_ease_in_out_quad);
#if PERL_VERSION_LE(5, 21, 5)
#  if PERL_VERSION_GE(5, 9, 0)
    if (PL_unitcheckav)
        call_list(PL_scopestack_ix, PL_unitcheckav);
#  endif
    XSRETURN_YES;
#else
    Perl_xs_boot_epilog(aTHX_ ax);
#endif
}

